var prefObj = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
var fgPrefsBranch = prefObj.getBranch("foxgame.userprefs.");

var fgboolPrefsTrue = new Array("foxgameRemovePlanets", "foxgameFlotaTime", "foxgameReplicateDeleteOptions", 
				"foxgameSelectUniverse", "foxgameResearchTime", "foxgameHighlightBigDebris",
				"foxgameBuildingsTime", "foxgameBuildingTime", "foxgameFlotaReturnTime",
				"foxgamePhalanxTime", "foxgameAddPhalanxIndicator", "foxgameShowRankDiffs", "foxgameAddRaid",
				"foxgameSetFocus", "foxgameShowEnergyInfo", "foxgameShowCargoNeeded", 
				"foxgamePlanetButtons", "foxgamePhalanxRangeInfo", "foxgameShowProdPercent",
				"foxgameShowFleetCargo");


var fgboolPrefsFalse = new Array("foxgameAddMilosButtons", "foxgameAddOverviewTime", "foxgameRemoveOverviewTime", "foxgameReplicateSpyReportOptions",
				"foxgameAutoCopy","foxgameMessageSignature","foxgameAddReportButtons",
				"foxgameAddStatButtons", "foxgameDragoSimLink", "foxgameSpeedSimLink",
				"foxgameAddDebrisNumbers", "foxgameShowAllyRank", "foxgameShowPlayerRank", "foxgameReducedSDR",				
				"foxgameSetAccessKey", "foxgameReducedB", "foxgameShowEnergyResources",
				"foxgameFastReply");

var fgcharPrefs = new Array("fgDebrisMin", "fgMsgSign", "fgPersonaldate", "fgPersonalhour", "foxgameAddRaidSize",
				"foxgameAccessKey");

var fgcolorPrefs = new Array("fgDebrisColor");

var fgcharPrefsSelects = new Array("fgTimeMode", "fgTimeDiff");
//"fgServer","fgUni", 

function fillListFromXml(id, prefix, xmlDoc, elem, descAttr, valAttr){
    
    var values = xmlDoc.getElementsByTagName(elem);
    var menupopup = document.getElementById(id);
    var langs = new Array();
    	
    for (var i=0; i<values.length; i++) {
        var label = values[i].attributes.getNamedItem(descAttr).textContent;
        var value = values[i].attributes.getNamedItem(valAttr).textContent;
        langs[langs.length] = new Array(label,value);
    }

    function sortfunction(a,b) {
        return a[0].localeCompare(b[0]);
    }
    
    langs.sort(sortfunction);

    for (var i=0; i<langs.length; i++) {
        
        var label = langs[i][0];
        var value = langs[i][1];

        var obj = document.createElement("menuitem");
        obj.setAttribute("id", prefix+value);
        obj.setAttribute("label", label);
        obj.setAttribute("value", value);
        
        menupopup.appendChild(obj);
        
    }

}

function fillSubListFromXml(id, prefix, xmlDoc, elem, descAttr, valAttr, fatherElem, fatherAtrr, fatherVal){
    
    try {
	//alert('//'+fatherElem+'[@'+fatherAtrr+'="'+fatherVal+']/descendant::'+elem);
    var values = xmlDoc.evaluate('//'+fatherElem+'[@'+fatherAtrr+'="'+fatherVal+'"]/descendant::'+elem,xmlDoc,null,XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null)
    var menupopup = document.getElementById(id);

    while (menupopup.childNodes.length > 0) {
	menupopup.removeChild(menupopup.firstChild);
    }
    
    var langs = new Array();
    
	
    for (var i=0; i<values.snapshotLength; i++) {
        var label = values.snapshotItem(i).attributes.getNamedItem(descAttr).textContent;
        var value = values.snapshotItem(i).attributes.getNamedItem(valAttr).textContent;
        langs[langs.length] = new Array(label,value);
    }

    function sortfunction(a,b) {
        return a[0].localeCompare(b[0]);
    }
    
    langs.sort(sortfunction);

    for (var i=0; i<langs.length; i++) {
        
        var label = langs[i][0];
        var value = langs[i][1];

        var obj = document.createElement("menuitem");
        obj.setAttribute("id", prefix+value);
        obj.setAttribute("label", label);
        obj.setAttribute("value", value);
        
        menupopup.appendChild(obj);    
    }
	} catch(e) {
		alert(e);
	}
}

function loadUnis(){
	try {
	var server = document.getElementById("fgServer").selectedItem.value;
	fillSubListFromXml("fgUniPopup", "fgUni-", fgUniversesXml, "universe", "name", "value", "index", "url", server);
	document.getElementById("fgUni").selectedItem = null;
	} catch(e) { }
}

function initFoxGamePreferences() {
       
    for (var i=0; i < fgboolPrefsTrue.length; i++) {
        try {
            var temp = fgboolPrefsTrue[i];
            document.getElementById(temp).checked=fgGetBooleanPref(temp,true);
        } catch (e) {
		document.getElementById(temp).checked=true;
	  }
    }
    for (var i=0; i<fgboolPrefsFalse.length; i++) {
        try {
            var temp = fgboolPrefsFalse[i];
            document.getElementById(temp).checked=fgGetBooleanPref(temp,false);
        } catch (e) {
		document.getElementById(temp).checked=false;
	  }
    }

    for (var i=0; i<fgcharPrefs.length; i++) {
        try {
            var temp = fgcharPrefs[i];
            document.getElementById(temp).value=fgPrefsBranch.getCharPref(temp);
        } catch (e) {}
    }

    for (var i=0; i<fgcolorPrefs.length; i++) {
        try {
            var temp = fgcolorPrefs[i];
            document.getElementById(temp).value=fgPrefsBranch.getCharPref(temp);
        } catch (e) {
		document.getElementById(temp).value="#CC0000";
	  }
    }

    for (var i=0; i<fgcharPrefsSelects.length; i++) {
        try {
            var temp = fgcharPrefsSelects[i];
            document.getElementById(temp).selectedItem=document.getElementById(temp + "-" + fgPrefsBranch.getCharPref(temp));
		if (temp == "fgServer")
		  loadUnis();
        } catch (e) {}
    } 

    
	function fg_getPref(pref) {
		try {
			return PrefsBranchFG.getCharPref(pref)
		} catch(e) {
			return "-1";
		}
	}

	var i = 0;
	var lista = document.getElementById("fg_missionPriorities");

	var pref = fg_getPref("fgMissionPreference"+i);
	var button;
 	while (pref != "-1") {
      	button = document.getElementById("fg_missionButton"+pref);
		lista.appendItem((lista.getRowCount()+1)+". "+button.label,pref);
		button.setAttribute('hidden','true');
		i++;
		pref = fg_getPref("fgMissionPreference"+i);
	} 
	if (document.getElementById('fgPersonaldate').value == "d/MM" || document.getElementById('fgPersonaldate').value == "MM/d")
		document.getElementById('fgDateFormat').value = document.getElementById('fgPersonaldate').value;
	else {
		document.getElementById('fgDateFormat').value = '2';
		document.getElementById('foxgamePersonalDate').setAttribute('hidden','false'); 
	}
	if (document.getElementById('fgPersonalhour').value == "H:mm:ss" || document.getElementById('fgPersonalhour').value == "K:mm:ss a")
		document.getElementById('fgHourFormat').value = document.getElementById('fgPersonalhour').value;
	else {
		document.getElementById('fgHourFormat').value = '2';
		document.getElementById('foxgamePersonalHour').setAttribute('hidden','false'); 
	}
		

	if(document.getElementById("fgTimeMode").value == "3")
		document.getElementById("fgTimeDiffBox").setAttribute('hidden','false');
}


function savePreferences() {
    
    try {

        for (var i=0; i<fgboolPrefsFalse.length; i++) {
            var temp = fgboolPrefsFalse[i];
            fgPrefsBranch.setBoolPref(temp, document.getElementById(temp).checked);
        }
        for (var i=0; i<fgboolPrefsTrue.length; i++) {
            var temp = fgboolPrefsTrue[i];
            fgPrefsBranch.setBoolPref(temp, document.getElementById(temp).checked);
        }
        for (var i=0; i<fgcharPrefs.length; i++) {
            var temp = fgcharPrefs[i];
            fgPrefsBranch.setCharPref(temp, document.getElementById(temp).value);
        }
        for (var i=0; i<fgcolorPrefs.length; i++) {
            var temp = fgcolorPrefs[i];
            fgPrefsBranch.setCharPref(temp, document.getElementById(temp).value);
        }

        for (var i=0; i<fgcharPrefsSelects.length; i++) {
            var temp = fgcharPrefsSelects[i];
            if (document.getElementById(temp).selectedItem != null) {
                fgPrefsBranch.setCharPref(temp, document.getElementById(temp).value);
            }
        }
        
	  var lista = document.getElementById("fg_missionPriorities");
	  var i = 0;
  	  for (i = 0; i < lista.getRowCount(); i++) {
            fgPrefsBranch.setCharPref("fgMissionPreference"+i, lista.getItemAtIndex(i).value);	
	  }
        fgPrefsBranch.setCharPref("fgMissionPreference"+i, "-1");

        return true;
        
    } catch (e) {
        alert (e);
        return true;
    }

    
}


//---------------------------------------------------------------
function initWindow() {

	initFoxGamePreferences();	    
}

function foxgame_getSortedKeysForArray(values, sortProperty) {
 
    var keys = new Array();
    
    for (var key in values) {
        keys[keys.length] = key;
    }
    
    function sortfunction(a,b) {
        return values[a][sortProperty].localeCompare(values[b][sortProperty]);
    }
    
    keys.sort(sortfunction);
    
    return keys;
    
}
//---------------------------------------------------------------
function fg_initColor() {
	var ele = window.arguments[0];
	try {
      	document.getElementById("fgColorPicker").color=window.opener.document.getElementById(ele).value;		
	} catch(e) {
		document.getElementById("fgColorPicker").color="#CC0000";
	}
}

function fg_saveColor() {

	var pref = window.arguments[0];
    fgPrefsBranch.setCharPref(pref, document.getElementById("fgColorPicker").color);

	return true;
}
function fg_returnColor() {
	var ele = window.arguments[1];
	try {
		window.opener.document.getElementById(ele).value = document.getElementById("fgColorPicker").color;
	} catch(e) {
		alert(e);
	}
}

function fg_openColor(pref,ele) {
	window.openDialog('chrome://foxgame/content/foxGameColorPicker.xul','ColorPicker','chrome',pref,ele);
	return true;
}

function fg_borrarLista(id,prefix) {
	var a = document.getElementById(id);
	var id2;
	var button;
	while(a.getRowCount() > 0) {
		id2 = prefix + a.getItemAtIndex(0).value;
		button = document.getElementById(id2);
		button.setAttribute("hidden","false");
		a.removeItemAt(0);
	}
	document.getElementById(prefix+1).focus();
}
function fg_borrarUltimo(id, prefix) {
	var a = document.getElementById(id);
	var id2 = prefix + a.getItemAtIndex(a.getRowCount()-1).value;
	var button = document.getElementById(id2);
	button.setAttribute("hidden","false");
	a.removeItemAt(a.getRowCount()-1);
	document.getElementById(prefix+1).focus();
}
function fg_anadir(id,label,value) {
	var a = document.getElementById(id);
	a.appendItem((a.getRowCount()+1)+". "+label,value);
}

//------------------------------------------ Tree functions

function fg_TreeView() {
    this.data = null;
    this.treeBox = null;
    this.selection = null;
    this.init = function(lista) {
	this.data = lista;
	};
    this.rowCount = function() {	
	return this.data.length;
    };

/*    get rowCount() {
	return this.data.length;
    },
*/
    this.getCellText = function(row,column){
	return eval("this.data.value(row)."+column.id);
    };
    this.setTree = function(treebox){ this.data.setTree(treebox); this.treeBox = treebox;};
    this.isContainer = function(row){ return false; };
    this.isSeparator = function(row){ return false; };
    this.isSorted = function(){ return false; };
    this.getLevel = function(row){ return 0; };
    this.getImageSrc = function(row,col){ return null; };
    this.getRowProperties = function(row,props){};
    this.getCellProperties = function(row,col,props){};
    this.getColumnProperties = function(colid,col,props){};
};
var treeView = new Array ();
treeView[0] = new fg_TreeView();
treeView[1] = new fg_TreeView();
treeView[2] = new fg_TreeView();
treeView[2].getCellText = function(row,column){	
	var temp = eval("this.data.value(row)."+column.id);
	if (temp == "PM")
		return document.getElementById("foxgame.prefs.messageTypePM").value;
	else if (temp == "CC")
		return document.getElementById("foxgame.prefs.messageTypeCC").value;		
	else if (temp == "SpyReport")
		return document.getElementById("foxgame.prefs.messageTypeSpyR").value;		
	else if (temp == "SpyReport")
		return document.getElementById("foxgame.prefs.messageTypeSpyA").value;		
	else if (temp == "Missile")
		return document.getElementById("foxgame.prefs.messageTypeMissile").value;
	else {
		if ( column.id == "priority")
			return (row+1)+"";
					
		return temp;
	}				
};

function fg_treeSetView()
{
	fg_listaDBs.init(fg_getConfigFile("dbs.xml"));
	treeView[0].init(fg_listaDBs);
	document.getElementById('list').view=treeView[0];
	fg_listaDBs.load();
	fg_listaLogins.init(fg_getConfigFile("logins.xml"));
	treeView[1].init(fg_listaLogins);
	document.getElementById('loginList').view=treeView[1];
	fg_listaLogins.load();
	fg_listaHighlights.init(fg_getConfigFile("hl.xml"));
	treeView[2].init(fg_listaHighlights);
	document.getElementById('listHL').view=treeView[2];
	fg_listaHighlights.load();
}
function fg_treeEditElement(id) {
	var treeView2 = treeView[id];
	if (treeView2.selection.getRangeCount() == 0) return;
	var i = treeView2.selection.currentIndex;
	var result = {};
	openDialog("chrome://foxgame/content/edit"+treeView2.data.type+".xul", "_blank", "chrome,centerscreen,modal", treeView2.data.value(i), result);
	treeView2.data.modifyElement(i,result);   	
}

function fg_treeUpElement(id) {
	var treeView2 = treeView[id];
	if (treeView2.selection.getRangeCount() == 0) return;
	var i = treeView2.selection.currentIndex;
	if (i < 1) {
		return;
	}
	var temp = treeView2.data.value(i);
	treeView2.data.setValue(i,treeView2.data.value(i-1));
	treeView2.data.setValue(i-1,temp);	
}

function fg_treeDownElement(id) {
	var treeView2 = treeView[id];
	if (treeView2.selection.getRangeCount() == 0) return;
	var i = treeView2.selection.currentIndex;
	if (i > treeView2.data.length - 2 )
		return;
	var temp = treeView2.data.value(i);
	treeView2.data.setValue(i,treeView2.data.value(i+1));
	treeView2.data.setValue(i+1,temp);		
}

function fg_treeAddElement(id) {
	var treeView2 = treeView[id];
	var result = {};
	openDialog("chrome://foxgame/content/edit"+treeView2.data.type+".xul", "_blank", "chrome,centerscreen,modal", '', result);
	treeView2.data.addElement(result);
}
function fg_treeDeleteElement(id) {
	var treeView2 = treeView[id];
      var min = {};
      var max = {};
	while(treeView2.selection.getRangeCount() > 0)
	{
		treeView2.selection.getRangeAt(0, min, max);
		treeView2.data.removeElement(min.value);
	}
}